{ config, pkgs, ... }:

{
  # Enable the DNS module
  pepe.core.dns = {
    enable = true;
    nextDNSId = "d65174";
    extraDomains = {
      "architect.devs.giugl.io" = { 
        dnsInterfaces = [ "lan" "tailscale" ]; 
      };
    };
  };

  # Configure AdGuard
  pepe.core.vhost.hosts."adguard.giugl.io" = {
    locations."/" = {
      port = config.services.adguardhome.port;
      allowLAN = true;
      allowVPN = true;
    };
  };
}
