{ config, pkgs, ... }:

let
  domain = "monitor.giugl.io";
in
{
  services.netdata = {
    enable = true;
    package = pkgs.unstablePkgs.netdata;
    config = {
      db.mode = "dbengine";
    };
  };

  architect.vhost.${domain} = with config.architect.networks; {
    dnsInterfaces = [ "tailscale" "lan" ];

    locations."/" = {
      port = 19999;
      allowLan = true;
      allow = [
        tailscale.net
      ];
    };
  };
}
