{ pkgs, config, lib, ... }:

let
  domain = "devs.giugl.io";

  utilities = import ./utilities.nix { inherit lib config; };
  inherit (utilities) generateDeviceStrings;
in
{
  pepe.core.network.interfaces.tailscale = {
    interface = "ts0";
    net = "100.64.0.0/10";
    type = "vpn";
    devices = {
      architect = { address = "100.64.0.1"; hostname = "architect.${domain}"; };
      kmerr = { address = "100.64.0.2"; hostname = "kmerr.${domain}"; };
      chuck = { address = "100.64.0.4"; hostname = "chuck.${domain}"; };
      dodino = { address = "100.64.0.5"; hostname = "dodino.${domain}"; };
      manduria = { address = "100.64.0.6"; hostname = "manduria.${domain}"; };
      tommy = { address = "100.64.0.7"; hostname = "tommy.${domain}"; };
      alfredo = { address = "100.64.0.9"; hostname = "alfredo.${domain}"; };
      appletv = { address = "100.64.0.13"; hostname = "appletv.${domain}"; };
      watkinshouse = { address = "100.64.0.14"; hostname = "watkinshouse.${domain}"; };
      afsun = { address = "100.64.0.15"; hostname = "afsun.${domain}"; };
      jacopo-desktop = { address = "100.64.0.21"; hostname = "afsun.${domain}"; };
      jacopo-tv = { address = "100.64.0.22"; hostname = "afsun.${domain}"; };
    };
  };

  services = {
    tailscale = {
      enable = true;
      interfaceName = config.pepe.core.network.interfaces.tailscale.interface;
      package = pkgs.unstablePkgs.tailscale;
    };
  };

  networking.extraHosts = generateDeviceStrings config.architect.networks.tailscale.devices;
}
